//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3768133EFB2D.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3768133EFB2D.cm

//## begin module%3768133EFB2D.cp preserve=no
//## end module%3768133EFB2D.cp

//## Module: ComponentGroup%3768133EFB2D; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/ComponentGroup.h

#ifndef COMPONENTGROUP_H
#define COMPONENTGROUP_H 1

//## begin module%3768133EFB2D.additionalIncludes preserve=no
//## end module%3768133EFB2D.additionalIncludes

//## begin module%3768133EFB2D.includes preserve=yes
#include "xsTypes.h"
//## end module%3768133EFB2D.includes

// xsTypes
#include <main/xsTypes.h>
// Error
#include <XSUtil/Error/Error.h>
// ModelBase
#include <XSModel/Model/ModelBase.h>
// ComponentListTypes
#include <XSModel/Model/Component/ComponentListTypes.h>

class SumComponent;
class CGroupBase;

//## begin module%3768133EFB2D.declarations preserve=no
//## end module%3768133EFB2D.declarations

//## begin module%3768133EFB2D.additionalDeclarations preserve=yes
template <typename T> class ModelExpression;
//## end module%3768133EFB2D.additionalDeclarations


//## begin ComponentGroup%3628077800B4.preface preserve=yes
//## end ComponentGroup%3628077800B4.preface

//## Class: ComponentGroup%3628077800B4; private
//	Component Group Contains one or many components that are
//	combined together, for example a number of additive
//	models that are all combined by a single multiplicative
//	or convolution component.
//
//
//	It is a concrete class which has also one derivation,
//	the background Component Group. This is distinguished by
//	having a unit efficiency matrix (auxiliary response file)
//	     rather than the auxiliary response supplied by the
//	dataset
//	     to be modelled.
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%376812CCF83D;private: StringList { -> }
//## Uses: <unnamed>%3A8425A50083;ModelBase { -> }
//## Uses: <unnamed>%3A8D5B4802D0;SumComponent { -> F}
//## Uses: <unnamed>%3AB66EC2002C;ComponentList { -> }

class ComponentGroup 
{
  //## begin ComponentGroup%3628077800B4.initialDeclarations preserve=yes
  //## end ComponentGroup%3628077800B4.initialDeclarations

  public:
    //## Class: NoSuchComponent%3A8D4A85033F
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoSuchComponent : public YellowAlert  //## Inherits: <unnamed>%3A8D4AE6022A
    {
      public:
        //## Constructors (specified)
          //## Operation: NoSuchComponent%3A8D4A9C03B7
          NoSuchComponent (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (generated)
      ComponentGroup(const ComponentGroup &right);

    //## Constructors (specified)
      //## Operation: ComponentGroup%376812CCF250;      C++
      ComponentGroup (ModelExpression<ModExprTreeMember>& gs, ModelBase* parent, bool nested = false);

    //## Destructor (generated)
      ~ComponentGroup();

    //## Assignment Operation (generated)
      ComponentGroup & operator=(const ComponentGroup &right);


    //## Other Operations (specified)
      //## Operation: calculate%376812CCF839;          C++
      //	Additional Public Declarations
      void calculate (bool saveComponentFlux = false, bool frozen = false);

      //## Operation: operator<<%376812CDF940;  C++
      friend std::ostream& operator << (std::ostream& s, const ComponentGroup& right);

      //## Operation: operator>%39D3613800F2
      bool operator > (const ComponentGroup& right) const;

      //## Operation: clone%3A843801021D
      ComponentGroup* clone () const;

      //## Operation: elements%3A8C4406009E
      const ComponentList& elements () const;

      //## Operation: operator<%3A8C445D013A
      bool operator < (const ComponentGroup& right) const;

      //## Operation: getElements%3A8C4E1A00CF
      const Component* getElements (const string& componentName) const;

      //## Operation: setElements%3A8C4E5401FC
      void setElements (const string& componentName, const Component* value);

      //## Operation: resetComponentFlux%3CB5F0D7034D
      void resetComponentFlux () const;

      //## Operation: groupFlux%3A8D5901003F
      SumComponent* groupFlux ();

      //## Operation: registerParameters%3A9EA58400FE
      void registerParameters () const;

      //## Operation: localParameter%3AA938390374
      Parameter* localParameter (size_t i) const;

      //## Operation: isNested%3AE855D200E0
      bool isNested () const;

      //## Operation: sum%3AE86837010E
      const SumComponent* sum () const;

      //## Operation: checkNorms%3C89157C02A8
      void checkNorms (IntegerArray& paramsToFreeze) const;

      //## Operation: setComputeFlag%3C20EC90030F
      void setComputeFlag (bool value);

      //## Operation: normParams%3C6D2FAB01CB
      std::list<ModParam*> normParams () const;

      //## Operation: clearArrays%3C7670A30172
      void clearArrays (const std::set<UniqueEnergy*>& currentEngs);

      //## Operation: getVariableParameters%3C7BA4B801C1
      std::vector<ModParam*> getVariableParameters () const;

      //## Operation: saveComponentFlux%3CB71C0B012E
      void saveComponentFlux () const;

      //## Operation: combine%3D08C0D10146
      void combine ();

      //## Operation: sources%3DE7A5B401CC
      std::list<SumComponent*> sources ();

      //## Operation: deleteComponent%3EF9EBED027D
      void deleteComponent (int sequenceNumber, int index);

      //## Operation: setNestedElement%3F01F44401AA
      void setNestedElement (const string& componentName, Component* value);

      //## Operation: resetElement%3F1EBBA6027A
      void resetElement (XSModExpTree<ComponentGroup*>& newGroups, const std::vector<Component*>& existingComponents);

      //## Operation: componentByNumber%3F1ECC8A016D
      Component* componentByNumber (int index) const;

      //## Operation: insertComponent%3F26BB8D026D
      void insertComponent (int location, int index, const string& name, char op);

      //## Operation: exchangeComponent%4512A7490047
      void exchangeComponent (int location, Component* newComponent);

      //## Operation: createComponent%4512D996005E
      Component* createComponent (string& name);

      //## Operation: deregisterParameters%3F297F1F020D
      void deregisterParameters () const;

      //## Operation: firstComponent%3F72034001BF
      Component* firstComponent ();

      //## Operation: addToElements%4134D0490138
      void addToElements (int componentOffset, Component* newComponent);

      //## Operation: parent%41361FF600B6
      const ModelBase* parent () const;

      //## Operation: componentInfo%41362FB901F2
      const ModelExpression<ModExprTreeMember>* componentInfo () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: GROUPTEST%3E8C7F4100B8
      static const string& GROUPTEST ();

  public:
    // Additional Public Declarations
      //## begin ComponentGroup%3628077800B4.public preserve=yes
      friend class ModelBase;
      void setComponentInfo(ModelExpression<ModExprTreeMember>* expr);
      //## end ComponentGroup%3628077800B4.public
  protected:
    // Additional Protected Declarations
      //## begin ComponentGroup%3628077800B4.protected preserve=yes
      //## end ComponentGroup%3628077800B4.protected

  private:

    //## Other Operations (specified)
      //## Operation: setElement%376812CCF83E;      C++
      void setElement (XSModExpTree<ComponentGroup*>& componentGroups);

      //## Operation: swap%3A8D499A02CF
      //## Exceptions: ()
      void swap (ComponentGroup& right) throw ();

      //## Operation: parent%3DD003D402E5
      void parent (ModelBase* p);

      //## Operation: resizeElements%405B5AD50087
      void resizeElements (size_t n);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::<unnamed>%3A8C3E890270
      //## Role: ComponentGroup::groupBase%3A8C3E8A02B1
      const CGroupBase* groupBase () const;
      void groupBase (CGroupBase* value);

    // Additional Private Declarations
      //## begin ComponentGroup%3628077800B4.private preserve=yes
      //## end ComponentGroup%3628077800B4.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin ComponentGroup::GROUPTEST%3E8C7F4100B8.attr preserve=no  public: static string {VC} "$GROUP"
      static const string s_GROUPTEST;
      //## end ComponentGroup::GROUPTEST%3E8C7F4100B8.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3A8C3E890270
      //## begin ComponentGroup::groupBase%3A8C3E8A02B1.role preserve=no  private: CGroupBase { -> 1RFHgN}
      CGroupBase* m_groupBase;
      //## end ComponentGroup::groupBase%3A8C3E8A02B1.role

    // Additional Implementation Declarations
      //## begin ComponentGroup%3628077800B4.implementation preserve=yes
      //## end ComponentGroup%3628077800B4.implementation

};

//## begin ComponentGroup%3628077800B4.postscript preserve=yes
//## end ComponentGroup%3628077800B4.postscript

// Class ComponentGroup::NoSuchComponent 

// Class ComponentGroup 

//## Get and Set Operations for Class Attributes (inline)

inline const string& ComponentGroup::GROUPTEST ()
{
  //## begin ComponentGroup::GROUPTEST%3E8C7F4100B8.get preserve=no
  return s_GROUPTEST;
  //## end ComponentGroup::GROUPTEST%3E8C7F4100B8.get
}

//## Get and Set Operations for Associations (inline)

inline const CGroupBase* ComponentGroup::groupBase () const
{
  //## begin ComponentGroup::groupBase%3A8C3E8A02B1.get preserve=no
  return m_groupBase;
  //## end ComponentGroup::groupBase%3A8C3E8A02B1.get
}

inline void ComponentGroup::groupBase (CGroupBase* value)
{
  //## begin ComponentGroup::groupBase%3A8C3E8A02B1.set preserve=no
  m_groupBase = value;
  //## end ComponentGroup::groupBase%3A8C3E8A02B1.set
}

//## begin module%3768133EFB2D.epilog preserve=yes
//## end module%3768133EFB2D.epilog


#endif
